<template>
  <v-text-field
    v-model="search"
    color="accent"
    background-color="primary"
    solo
    prepend-inner-icon="mdi-magnify"
    :placeholder="$_t('components.countries.filters.search.placeholder')"
  ></v-text-field>
</template>

<script>
import { mapActions } from "vuex";

export default {
  name: "Search",
  data() {
    return {
      search: "",
    };
  },
  methods: {
    ...mapActions({
      fetchAllCountriesByName: "countries/fetchCountriesByName",

      /* loading handlers */
      startLoading: "loading/start",
      finishLoading: "loading/finish",
    }),

    searchByName(keyword) {
      if (keyword.length === 0) return;
      this.startLoading();
      this.fetchAllCountriesByName({ keyword: keyword }).finally(() => {
        this.finishLoading();
      });
    },
  },

  watch: {
    search: function (keyword) {
      this.searchByName(keyword);
    },
  },
};
</script>

<style scoped lang="scss">
.theme--dark.v-list {
  background: #2b3945;
}
.v-list-item__content {
  color: white !important;
}
.theme--dark.v-list-item:hover:before {
  opacity: 0.14;
}
</style>
